#ifndef INSTRUMENT_HH
#define INSTRUMENT_HH

#include "pin.H"
#include "ilptool_interface.hh"

const char * StripPath(const char * path);

// INSTRUMENTATION FUNCTION
VOID InstrumentAnalyse(IlptoolInterface *ilpobj, ADDRINT a, BOOL is_control, UINT32 op, UINT32 nr, UINT32 nw,
		       UINT32 rr0, UINT32 lenrr0,
		       UINT32 rr1, UINT32 lenrr1,
		       UINT32 rr2, UINT32 lenrr2,
		       UINT32 rr3, UINT32 lenrr3,
		       UINT32 rr4, UINT32 lenrr4,
		       UINT32 rr5, UINT32 lenrr5,
		       UINT32 rr6, UINT32 lenrr6,
		       UINT32 rr7, UINT32 lenrr7,
		       UINT32 wr0, UINT32 lenwr0,
		       UINT32 wr1, UINT32 lenwr1,
		       UINT32 wr2, UINT32 lenwr2,
		       UINT32 wr3, UINT32 lenwr3,
		       UINT32 wr4, UINT32 lenwr4,
		       UINT32 wr5, UINT32 lenwr5,
		       UINT32 wr6, UINT32 lenwr6,
		       UINT32 wr7, UINT32 lenwr7,
		       ADDRINT amr, UINT32 rsize, ADDRINT amr2, ADDRINT amw, UINT32 wsize, UINT32 xed_category);


// Pin calls this function every time a new rtn is executed
VOID InstrumentRoutine(RTN rtn, VOID *v);

// This function is called when the application exits
// It prints the name and count for each procedure
VOID InstrumentFini(INT32 code, VOID *v);


#endif //  INSTRUMENT_HH
